// Viewer.java

import java.io.*;
import java.util.ArrayList;
import javax.swing.*;

public class Viewer
{
   public static void main (String [] args)
   {
      if (args.length != 1)
      {
          System.out.println ("usage: java Viewer filename");
          return;
      }

      ArrayList<String> lines = new ArrayList<String> ();

      BufferedReader br = null;
      try
      {
          FileReader fr = new FileReader (args [0]);
          br = new BufferedReader (fr);

          String line;
          while ((line = br.readLine ()) != null)
             lines.add (line);
      }
      catch (IOException e)
      {
          System.out.println ("unable to read " + args [0]);
          return;
      }
      finally
      {
          try
          {
              if (br != null)
                  br.close ();
          }
          catch (IOException e)
          {
          }
      }

      JList list = new JList (lines.toArray ());

      JFrame frame = new JFrame ("Viewer: " + args [0]);
      frame.setDefaultCloseOperation (JFrame.EXIT_ON_CLOSE);
      frame.add (new JScrollPane (list));
      frame.setSize (300, 300);
      frame.setVisible (true);
   }
}
