# ===========================================================================
# jython.py
#
# Demonstrate Jython.
#
# Note: The article's excerpts differ from this script in three ways:
#
# 1) The indentation is different. I used the Tab key to handle indentation
#    when interactively keying in the excerpts.
#
# 2) I output all expressions with the print statement. Although print is not
#    needed in interactive mode, it is needed when running jython.py.
#
# 3) I commented out john.__age to prevent premature script termination.
# ===========================================================================

print 4*3*2*1 # Calculate 4 factorial.
print 3.14159*45/180 # Convert 45 degrees to radians equivalent.
print "Hello, "+"World" # Concatenate to strings.

#

pi=3.14159 # Variable types are inferred from expressions.
print pi
i=j=k=1 # Multiple variables can be assigned the same value.
print i
print j
print k
cn1=30+2j # Jython supports complex numbers.
print cn1.real # You can access the real part...
print cn1.imag # ...and the imaginary part.
cn2=15-6j
print cn1+cn2 # You can also perform standard complex arithmetic.
str1="String 1" # Strings can be enclosed in double quotes...
print str1
str2='String 2' # ...or in single quotes.
print str2
print str1[0] # Single characters can be extracted using an index.
print str1[0:2] # A substring can be returned via two indexes separated by a colon.
print str2[2:] # With no second index, substring continues to end of string.
print str2[:3] # With no first index, substring begins at start of string.

#

languages=['Jython',"JRuby",'Groovy'] # Create a list.
print languages
languages[0]="Java" # Replace the first list item.
print languages
languages=languages+['Jython'] # Append a list item.
print languages
languages[0:1]=[] # Remove a list item.
print languages
print len(languages) # The len() function returns a list's length.
languages[1]=[1,"Groovy",3] # Lists can contain different-typed values.
print languages # Furthermore, lists can contain lists.

#

fact=n=1
while n < 11:
 print n, fact
 n=n+1
 fact=fact*n
for age in [50,57,68]:
 if age < 55:
  print "Not eligible for early retirement"
 elif age < 65:
  print "Not eligible for traditional retirement"
 else:
  print "Retired"
for i in range(0,10):
 print "i =", i

#

def fact(n):
 i=factorial=1
 while i <= n:
  factorial=factorial*i
  i=i+1
 return factorial

for i in range(0,11):
 print "i =", i, ": fact =", fact(i)

#

class Employee:
 name=""
 __age=0
 def __init__(self,name,age):
  self.name=name
  self.__age=age
 def getAge(self):
  return self.__age
john=Employee("John Doe",37) # Construct Employee object.
print john.name
# john.__age
print john.getAge()

#

from java.util import StringTokenizer
s = StringTokenizer("Jython can easily access Java classes")
print s.nextToken()
print s.nextToken()
print s.nextToken()
print s.nextToken()
print s.nextToken()
print s.nextToken()
print s.nextToken() # Guess what happens?
